AC_DEFUN(EIF_FD_SET_NEEDS_STRUCT,[
	AC_CACHE_CHECK([whether fd_set needs 'struct'], ac_cv_fd_set_needs_struct,
		[
		AC_TRY_COMPILE([
			#ifdef	HAVE_SYS_SELECT_H
			#include	<sys/select.h>
			#endif
			#ifdef	HAVE_SYS_TIME_H
			#include	<sys/time.h>
			#endif
			#include	<sys/types.h>
		],[
			fd_set		a;
		],ac_cv_fd_set_needs_struct=no,AC_TRY_COMPILE([
			#ifdef	HAVE_SYS_SELECT_H
			#include	<sys/select.h>
			#endif
			#ifdef	HAVE_SYS_TIME_H
			#include	<sys/time.h>
			#endif
			#include	<sys/types.h>
		],[
			struct fd_set	a;
		],ac_cv_fd_set_needs_struct=yes, ac_cv_fd_set_needs_struct=no))
	])
	if test "$ac_cv_fd_set_needs_struct" = "yes"; then
		AC_DEFINE(FD_SET_NEEDS_STRUCT, struct)
	else
		AC_DEFINE(FD_SET_NEEDS_STRUCT,)
	fi
])

AC_DEFUN(EIF_READLINE_HANDLES_CONST,[
	SAVE_CFLAGS="${SAVE_CFLAGS}"
	CFLAGS="${CFLAGS} -Werror"
	AC_CACHE_CHECK([whether readline handles 'const char *'], ac_cv_readline_uses_const,
		[
		AC_TRY_COMPILE([
			#include	<readline/history.h>
		],[
			write_history("/dev/tty");
		],ac_cv_readline_uses_const=yes,ac_cv_readline_uses_const=no)
	])
	CFLAGS="${SAVE_CFLAGS}"
	if test "$ac_cv_readline_uses_const" = "yes"; then
		AC_DEFINE(READLINE_HANDLES_CONST, 1)
	fi
])

AC_DEFUN(EIF_READLINE_UNBIND_KEY,[
	SAVE_CFLAGS="${SAVE_CFLAGS}"
	CFLAGS="${CFLAGS} -Wimplicit-function-declaration -Werror"
	AC_CACHE_CHECK([whether readline.h prototypes 'rl_unbind_key'], ac_cv_readline_unbind_key,
		[
		AC_TRY_COMPILE([
			#include	<stdio.h>
			#include	<readline/readline.h>
		],[
			rl_unbind_key(1);
		],ac_cv_readline_unbind_key=yes,ac_cv_readline_unbind_key=no)
	])
	CFLAGS="${SAVE_CFLAGS}"
	if test "$ac_cv_readline_unbind_key" = "yes"; then
		AC_DEFINE(READLINE_UNBIND_KEY, 1)
	fi
])
